/* CPU Change Password Utility
   Copyright (C) 2001 dbaseiv.net

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA */

/* bgetpwent
   this essentially is a getpwent that works on any file rather then only
   /etc/passwd. Takes the filename to work with and a user to find. Returns
   a struct with all the user information stored in it. The struct is
   documented in cpu.h */

/* Written by Blake Matheny */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <bconf.h>
#include <sys/types.h>
#include <cpu.h>

struct bpasswd *
bgetpwent(filename, name)
char *filename;
char *name;
{
	struct bpasswd *result;
	FILE *passfile = NULL;
	char pass_char[512];
	int pass_size = 511;

	result = malloc(sizeof (struct bpasswd));

	if ((passfile = fopen(filename, "r")) == NULL)
		return NULL;

	while (fgets(pass_char, pass_size, passfile) != NULL) {
		char *m = pass_char;
		int num_tok = 0;
		char *toks;

		while (m != NULL && *m != 0) {
			toks = getToken(&m, ":");
			if (num_tok == 0)
				result->pw_name = toks;
			else if (num_tok == 1)
				result->pw_passwd = toks;
			else if (num_tok == 2)
				result->pw_uid = toks;
			else if (num_tok == 3)
				result->pw_gid = toks;
			else if (num_tok == 4)
				result->pw_gecos = toks;
			else if (num_tok == 5)
				result->pw_dir = toks;
			else if (num_tok == 6)
				result->pw_shell = toks;
			else
				break;
			num_tok++;
		}

		if (strcmp(result->pw_name, name) == 0)
			return result;

	}

	return NULL;
}
